import java.awt.image.BufferedImage;
import java.io.File;
import javax.imageio.ImageIO;
import java.io.IOException;

public class ColorConversion {
	// modeɂJ[e[u̐ݒ
	static void setTable( int[] colorconv_r, int[] colorconv_g, int[] colorconv_b,
									 int mode )
	{
		int    i, col;
		double rad;

		switch ( mode ) {
			case 0:
				// F]
				for ( i = 0; i < 256; ++ i ) {
					colorconv_r[ i ] = 255 - i;
					colorconv_g[ i ] = 255 - i;
					colorconv_b[ i ] = 255 - i;
				}
				break;

			case 1:
				// Px𔼕
				for ( i = 0; i < 256; ++ i ) {
					colorconv_r[ i ] = i / 2;
					colorconv_g[ i ] = i / 2;
					colorconv_b[ i ] = i / 2;
				}
				break;

			case 2:
				// ʎq
				for ( i = 0; i < 256; ++ i ) {
					colorconv_r[ i ] = ( i / 64 ) * 64;
					colorconv_g[ i ] = ( i / 64 ) * 64;
					colorconv_b[ i ] = ( i / 64 ) * 64;
				}
				break;

			case 3:
				// TCJ[u
				for ( i = 0; i < 256; ++ i ) {
					rad = Math.toRadians( (double)i / 256.0 * 720.0 );
					col = (int)( Math.sin( rad ) * 127.0 + 127.0 );
					colorconv_r[ i ] = col;
					colorconv_g[ i ] = col;
					colorconv_b[ i ] = col;
				}
				break;

			case 4:
				// ۂ
				for ( i = 0; i < 256; ++ i ) {
					colorconv_r[ i ] = i + 100;
					if ( 255 < colorconv_r[ i ] ) colorconv_r[ i ] = 255;
					colorconv_g[ i ] = i + 100;
					if ( 255 < colorconv_g[ i ] ) colorconv_g[ i ] = 255;
					colorconv_b[ i ] = i + 100;
					if ( 255 < colorconv_b[ i ] ) colorconv_b[ i ] = 255;
				}
				break;


			case 5:
				// Ԑ̎c
				for ( i = 0; i < 256; ++ i ) {
					colorconv_r[ i ] = i;
					colorconv_g[ i ] = 0;
					colorconv_b[ i ] = 0;
				}
				break;


			case 6:
				// ΐ̎c
				for ( i = 0; i < 256; ++ i ) {
					colorconv_r[ i ] = 0;
					colorconv_g[ i ] = i;
					colorconv_b[ i ] = 0;
				}
				break;


			case 7:
				// ̎c
				for ( i = 0; i < 256; ++ i ) {
					colorconv_r[ i ] = 0;
					colorconv_g[ i ] = 0;
					colorconv_b[ i ] = i;
				}
				break;

			default:
				// ͒lƏo͒l𓯂ɂ
				for ( i = 0; i < 256; ++ i ) {
					colorconv_r[ i ] = i;
					colorconv_g[ i ] = i;
					colorconv_b[ i ] = i;
				}
				break;
		} 
	}


	public static void main( String[] args ) {
		// ʊi[tO
		boolean result;
		// Fϊ[h
		int mode;
		// t@C
		String inname, outname;
		// 摜i[NX
		BufferedImage img = null;

		// ͂Rȏォ𒲂ׂ
		if ( 3 > args.length ) {
			// ͂R̏ꍇAgp@\
			System.out.println( "ColorConversion [JPG][oJPG][Ӱ]" );
			return;
		}

		// JPEGinnameɑigq".jpg"ȗȂj
		inname  = args[ 0 ];
		// oJPEGoutnameɑigq".jpg"ȗȂj
		outname = args[ 1 ];

		// [hmodeɑ
		try {
			// ϊA[hɑ
			mode = Integer.valueOf( args[ 2 ] );
		}
		catch( NumberFormatException ne )
		{
			System.out.println( "sł" );
			return;
		}

		// JPEG̓ǂݍ
		try {
			// inname(JPEG)ǂݍimgɃZbg
			img = ImageIO.read( new File( inname ) );
		} catch (Exception e) {
			// inname(JPEG)̓ǂݍ݂ɎsƂ̏
			 e.printStackTrace();
			return;
		}


		// 摜̐F̎`FbN
		if ( BufferedImage.TYPE_3BYTE_BGR != img.getType() )
		{
			System.out.println( "ΉĂȂJ[fłI("
									 + inname +")" );
			return;
		}

		// Fϊ
		int x, y;
		int width, height;
		int color, r, g, b;
		int p;
		int newcolor;

		// Fϊe[u
		int[] colorconv_r = new int[ 256 ];
		int[] colorconv_g = new int[ 256 ];
		int[] colorconv_b = new int[ 256 ];


		// Fϊe[uݒ
		setTable( colorconv_r, colorconv_g, colorconv_b, mode );

		// 摜TCY̎擾
		width = img.getWidth();
		height= img.getHeight();

		for ( y = 0; y < height; ++ y ) {
			for ( x = 0; x < width; ++ x ) {
				// (x,y)̐F擾
				color = img.getRGB( x, y );

				// Fr,g,bɕ
				r = ( color >> 16 ) & 0xff;
				g = ( color >> 8 ) & 0xff;
				b = color & 0xff;

				// r,g,b̐Fe[uŕϊ
				r = colorconv_r[ r ];
				g = colorconv_g[ g ];
				b = colorconv_b[ b ];

				// r,g,b̐F
				newcolor = ( r << 16 ) + ( g << 8 ) + b;

				// F(x,y)ɐݒ
				img.setRGB( x, y, newcolor );
			}
		}

		try {
			// imgoutname(oJPEG)ɕۑ
			result = ImageIO.write( img, "jpeg", new File( outname ) );
		} catch ( Exception e ) {
			// outname(oJPEG)̕ۑɎsƂ̏
			e.printStackTrace();
			return;
		}

		// ɏI
		System.out.println( "ɏI܂" );
	}
}
